package yrpg.bamp.basedata.plugin.util;

import kd.bos.encrypt.Encrypters;
import yrpg.bamp.basedata.common.DBType;

import java.sql.Connection;
import java.sql.Driver;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.Properties;

public class OtherSysDBConnUtil {

    /**
     * @param instance 默认为空
     * @return jdbc
     */
    public Connection getDBConnection(String instance, String host, String port, String username, String password, DBType dbType) throws Exception {
        Properties prop = new Properties();
        prop.setProperty("driverClassName", dbType.getDriver());
        prop.setProperty("url", dbType.getURL(host, Integer.valueOf(port), instance));
        prop.setProperty("user", username);
        prop.setProperty("password", password);

        prop.setProperty("connectTimeout", String.valueOf(30000));
        prop.setProperty("socketTimeout", String.valueOf(30000));
        prop.setProperty("initialTimeout", String.valueOf(30000));
        Driver driver = (Driver)Class.forName(prop.getProperty("driverClassName")).newInstance();
        try {
            return driver.connect(prop.getProperty("url"), prop);
        } catch (SQLException e) {
            throw new RuntimeException("建立数据库连接失败，"+e.getMessage());
        }
    }

    public  Connection getOrclConnection(String url, String username, String password) {
        Connection connection = null;
        // 加载Oracle驱动
        try {
            Class.forName("oracle.jdbc.driver.OracleDriver");
            // 连接数据库
            connection = DriverManager.getConnection(url, username, password);
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("建立数据库连接失败，"+e.getMessage());
        }
        return connection;
    }

    public Connection getIFSConnection(){
        Connection connection = null;
        String url = System.getProperty("ifs.orcl.url");
        String user = System.getProperty("ifs.orcl.user");
        String pwd = System.getProperty("ifs.orcl.pwd");
        user = Encrypters.decode(user);
        pwd = Encrypters.decode(pwd);
        // 加载Oracle驱动
        try {
            Class.forName("oracle.jdbc.driver.OracleDriver");
            // 连接数据库
            connection = DriverManager.getConnection(url, user, pwd);
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("建立数据库连接失败，"+e.getMessage());
        }
        return connection;
    }


}
